Imports System.Configuration
Imports System.Web.Services
Imports System.Xml

<WebService(Namespace:="http://www.endurasoft.com/todservices/", _
            Description:="Generates or Sets a Tip Of The Day")> _
Public Class TipOfTheDay
    Inherits System.Web.Services.WebService

#Region " Web Services Designer Generated Code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Web Services Designer.
        InitializeComponent()

        'Add your own initialization code after the InitializeComponent() call

    End Sub

    'Required by the Web Services Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Web Services Designer
    'It can be modified using the Web Services Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container()
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        'CODEGEN: This procedure is required by the Web Services Designer
        'Do not modify it using the code editor.
    End Sub

#End Region

    <WebMethod()> Public Function GetTip() As String
        Try
            ' Find the path to the tip file
            Dim strTipPath As String = System.Configuration.ConfigurationSettings.AppSettings()("TipFilePath")

            ' Open the tip file for reading
            Dim objXmlDoc As XmlDocument = New XmlDocument()
            objXmlDoc.Load(strTipPath)

            ' Pull the root node...
            Dim objRoot As XmlNode = objXmlDoc.DocumentElement

            ' Pull all of its children
            Dim objTipsList As XmlNodeList = objRoot.ChildNodes

            ' Select a random number
            Dim objRand As Random = New Random(CInt(DateTime.Now.Millisecond))

            ' Return a tip
            GetTip = objTipsList.Item(objRand.Next Mod objTipsList.Count).InnerText
        Catch ex As Exception
            GetTip = "Error retrieving the tip, " & ex.Message
        End Try
    End Function

    <WebMethod()> Public Function AddTip(ByVal strTip As String) As Boolean
        Try
            ' Find the path to the tip file
            Dim strTipPath As String = System.Configuration.ConfigurationSettings.AppSettings()("TipFilePath")

            ' Open the tip file for reading
            Dim objXmlDoc As XmlDocument = New XmlDocument()
            objXmlDoc.Load(strTipPath)

            ' Pull the root node...
            Dim objRoot As XmlNode = objXmlDoc.DocumentElement

            ' Add the new tip as the last child
            Dim objNewNode As XmlNode = objXmlDoc.CreateNode(XmlNodeType.Element, "Tip", "")
            objNewNode.InnerText = strTip
            objRoot.AppendChild(objNewNode)

            ' Write the XML stream back out
            Dim objXmlWriter As XmlTextWriter = New XmlTextWriter(strTipPath, Nothing)
            objXmlDoc.WriteContentTo(objXmlWriter)
            objXmlWriter.Close()

            ' Return
            AddTip = True
        Catch ex As Exception
            AddTip = False
        End Try
    End Function
End Class
