// ReverseString.h : Defines the ATL Server request handler class
//
#pragma once

namespace ReverseStringService
{
// all struct, enum, and typedefs for your webservice should go inside the namespace

// IReverseStringService - web service interface declaration
//
[
	uuid("8B57749E-80D9-4A18-96E4-F39E0DBEE610"), 
	object
]
__interface IReverseStringService
{
	[id(1)] HRESULT ReverseString([in] BSTR bstrInput, [out, retval] BSTR *bstrOutput);
};


// ReverseStringService - web service implementation
//
[
	request_handler(name="Default", sdl="GenReverseStringWSDL"),
	soap_handler(
		name="ReverseStringService", 
		namespace="urn:ReverseStringService",
		protocol="soap"
	)
]
class CReverseStringService :
	public IReverseStringService
{
public:
	// This is a sample web service method that shows how to use the 
	// soap_method attribute to expose a method as a web method
	[ soap_method ]
	HRESULT ReverseString(/*[in]*/ BSTR bstrInput, /*[out, retval]*/ BSTR *bstrOutput)
	{
		// Check the outgoing pointer...
		if ( bstrOutput == NULL ) return E_POINTER;

		// Reverse the characters
		*bstrOutput = SysAllocString(_wcsrev(bstrInput));
		
		return S_OK;
	}
	// TODO: Add additional web service methods here
}; // class CReverseStringService

} // namespace ReverseStringService
