using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;
using System.Data.OleDb;
using System.Web.Services.Protocols;
using System.Xml;
using System.Security;
using System.Security.Cryptography;
using System.Text;
using System.IO;

namespace LoginServer
{
	/// <summary>
	/// Summary description for Service1.
	/// </summary>
	public class Service1 : System.Web.Services.WebService
	{
        protected string m_strWellKnownGuid;
        private byte[] m_key;
        private byte[] m_iv;

		public Service1()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();

            // Initialize the well-known guid
            m_strWellKnownGuid = "{33EEA85E-D343-4a6f-A8DC-293A3EBB4C31}";

            // Create the DES key...note this and the initialization
            // vector must be the same as that used by the server
            // or the value cannot be decrypted...
            m_key = new byte[8];
            m_key[0] = 254;
            m_key[1] = 56;
            m_key[2] = 72;
            m_key[3] = 244;
            m_key[4] = 30;
            m_key[5] = 144;
            m_key[6] = 180;
            m_key[7] = 97;

            // Create the DES initialization vector
            m_iv = new byte[8];
            m_iv[0] = 103;
            m_iv[1] = 179;
            m_iv[2] = 216;
            m_iv[3] = 199;
            m_iv[4] = 37;
            m_iv[5] = 53;
            m_iv[6] = 122;
            m_iv[7] = 145;
        }

		#region Component Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}
		#endregion

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
		}

        protected string GetNewSessionToken()
        {
            // Simply create a new GUID
            Guid guid = Guid.NewGuid();
            return "{" + guid.ToString() + "}";
        }

        protected string EncryptToken(string strGuid)
        {
            // Concatenate our "secret" GUID with the
            // public session GUID we just created.
            string strSessionString = m_strWellKnownGuid + strGuid;

            // Convert the string to a byte array
            UTF8Encoding enc = new UTF8Encoding();
            byte[] bytIn = new byte[4096];
            ((System.Array)enc.GetBytes(strSessionString)).CopyTo(bytIn,0);

            // Create stream for decryption
            byte[] bytOut = new byte[4096];
            MemoryStream stmOut = new MemoryStream(bytOut);

            // Create the service provider
            DES des = new DESCryptoServiceProvider();

            // Create the crypto stream and buffer
            CryptoStream stmEncrypt = new CryptoStream(stmOut,des.CreateEncryptor(m_key,m_iv),CryptoStreamMode.Write);

            // Encrypt to memory stream
            stmEncrypt.Write(bytIn,0,strSessionString.Length);
            stmEncrypt.FlushFinalBlock();

            // Return Base64 version of this encrypted value
            return Convert.ToBase64String(bytOut,0,(int)stmOut.Position);
        }

		[WebMethod]
		public string Login(string strUsername, string strPassword)
		{
            // Check input strings
            if ( strUsername.Length == 0 ) throw new SoapException("Invalid username provided",new XmlQualifiedName("Client.InvalidParameter.EmptyUsername"));
            if ( strPassword.Length == 0 ) throw new SoapException("Invalid password provided",new XmlQualifiedName("Client.InvalidParameter.EmptyPassword"));

            // Create a new (empty) dataset
            DataSet ds = new DataSet();

            // Pull the connection string
            string strConn = System.Configuration.ConfigurationSettings.AppSettings["ConnectionString"];

            // Create the search string
            string strSQL = string.Format("SELECT * FROM UserInfo WHERE username = '{0}' AND password = '{1}'",strUsername,strPassword);

            // Create the connection, command,
            // and adapter objects
            OleDbConnection objConn = new OleDbConnection(strConn);
            OleDbCommand objCmd = new OleDbCommand(strSQL,objConn);
            OleDbDataAdapter objAdapter = new OleDbDataAdapter(objCmd);

            // Connect to the database and execute SQL query
            objConn.Open();

            // Fill DataSet with the results, if any
            objAdapter.Fill(ds,"UserInfo");

            // Check for data...we'll look at the id column...
            if ( ds.Tables[0].Rows[0][0].ToString() == String.Empty ) throw new SoapException("Invalid user, login denied",new XmlQualifiedName("Client.InvalidUser.UserUnknown"));

            // If we got this far, we have a valid user, so we'll 
            // create an session token, which is an encrypted
            // GUID.
            string strToken = GetNewSessionToken();
            ds.Tables[0].Rows[0][3] = strToken; // stored clear text

            // Now encrypt the token for transmission back to the user
            string strEncryptedToken = EncryptToken(strToken);

            // Get current date/time, add 5 minutes, and
            // write that to the database
            DateTime dtNow = DateTime.Now;
            dtNow.Add(new TimeSpan(0,0,5,0,0));
            ds.Tables[0].Rows[0][4] = ((Int64)dtNow.Ticks).ToString();

            // Update the database
            OleDbCommandBuilder objCmdBlder = new OleDbCommandBuilder(objAdapter);
            objAdapter.Update(ds,"UserInfo");

            // Close the connection
            objConn.Close();

            // Return the encrypted token...
            return strEncryptedToken;
        }
	}
}
