using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;
using System.Data.OleDb;
using System.Web.Services.Protocols;
using System.Xml;
using System.Security;
using System.Security.Cryptography;
using System.Text;
using System.IO;

namespace SecuredService
{
	/// <summary>
	/// Summary description for Service1.
	/// </summary>
	public class Service1 : System.Web.Services.WebService
	{
		protected string m_strWellKnownGuid;
		private byte[] m_key;
		private byte[] m_iv;

		public Service1()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();

			// Initialize the well-known guid
			m_strWellKnownGuid = "{33EEA85E-D343-4a6f-A8DC-293A3EBB4C31}";

			// Create the DES key...note this and the initialization
			// vector must be the same as that used by the server
			// or the value cannot be decrypted...
			m_key = new byte[8];
			m_key[0] = 254;
			m_key[1] = 56;
			m_key[2] = 72;
			m_key[3] = 244;
			m_key[4] = 30;
			m_key[5] = 144;
			m_key[6] = 180;
			m_key[7] = 97;

			// Create the DES initialization vector
			m_iv = new byte[8];
			m_iv[0] = 103;
			m_iv[1] = 179;
			m_iv[2] = 216;
			m_iv[3] = 199;
			m_iv[4] = 37;
			m_iv[5] = 53;
			m_iv[6] = 122;
			m_iv[7] = 145;
		}

		#region Component Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}
		#endregion

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
		}

		protected bool CheckSessionToken(string strSessionToken)
		{
			// We have two encrypted GUIDs smashed together, and the
			// one we want is the first. So we pull that out
			// after decrypting and check it against our "secret"
			// GUID...
			//
			// Convert the string to a byte array
			byte[] bytIn = new byte[4096];
			byte[] bytEnc = Convert.FromBase64String(strSessionToken);
			bytEnc.CopyTo(bytIn,0);
      
			// Create streams for decryption
			byte[] bytOut = new byte[4096];
			MemoryStream stmOut = new MemoryStream(bytOut);

			// Create the service provider
			DES des = new DESCryptoServiceProvider();

			// Create the crypto stream and buffer
			CryptoStream stmDecrypt = new CryptoStream(stmOut,des.CreateDecryptor(m_key,m_iv),CryptoStreamMode.Write);

			// Encrypt to memory stream
			stmDecrypt.Write(bytIn,0,bytEnc.Length);
			stmDecrypt.FlushFinalBlock();

			// Extract our secret GUID
			UTF8Encoding enc = new UTF8Encoding();
			string strSecretGuid = enc.GetString(bytOut,0,((int)stmOut.Position/2));
			string strPublicGuid = enc.GetString(bytOut,((int)stmOut.Position/2),((int)stmOut.Position/2));

			bool bIsValid = false;
			if ( strSecretGuid == m_strWellKnownGuid )
			{
				// Session GUID is decrypted, so now we test the secret
				// session GUID we gave them previously
				//
				// Create a new (empty) dataset
				DataSet ds = new DataSet();

				// Pull the connection string
				string strConn = System.Configuration.ConfigurationSettings.AppSettings["ConnectionString"];

				// Create the search string
				string strSQL = string.Format("SELECT * FROM UserInfo WHERE token = '{0}'",strPublicGuid);

				// Create the connection, command,
				// and adapter objects
				OleDbConnection objConn = new OleDbConnection(strConn);
				OleDbCommand objCmd = new OleDbCommand(strSQL,objConn);
				OleDbDataAdapter objAdapter = new OleDbDataAdapter(objCmd);

				// Connect to the database and execute SQL query
				objConn.Open();

				// Fill DataSet with the results, if any
				objAdapter.Fill(ds,"UserInfo");

				// Check for data...we'll look at the id column...
				if ( ds.Tables[0].Rows[0][0].ToString() == String.Empty ) throw new SoapException("Invalid user, login denied",new XmlQualifiedName("Client.AuthenticationError.UserUnknown"));

				// If we got this far, they're valid, but are they over
				// the time limit?
				DateTime dtThen = new DateTime(Convert.ToInt64(ds.Tables[0].Rows[0][4].ToString()));
				DateTime dtNow = DateTime.Now;
				if ( dtThen.CompareTo(dtNow) <= 0 )
				{
					// We haven't expired, so mark it as valid
					bIsValid = true;

					// Give them another time interval
					dtNow.Add(new TimeSpan(0,0,5,0,0));
					ds.Tables[0].Rows[0][4] = ((Int64)dtNow.Ticks).ToString();

					// Update the database
					OleDbCommandBuilder objCmdBlder = new OleDbCommandBuilder(objAdapter);
					objAdapter.Update(ds,"UserInfo");

					// Close the connection
					objConn.Close();
				}
				else
				{
					throw new SoapException("Login timed out, please log in again",new XmlQualifiedName("Client.AuthenticationError.LoginTimeout"));
				}
			}
			else
			{
				throw new SoapException("Invalid user, login denied",new XmlQualifiedName("Client.AuthenticationError.InvalidLoginToken"));
			}

			return bIsValid;
		}

		[WebMethod]
		public string GetServerTime(string strSessionToken)
		{
			// Check the session token
			if ( !CheckSessionToken(strSessionToken) ) throw new SoapException("You are not authorized to use this Web Service...",new XmlQualifiedName("Client.AuthenticationError.UnauthorizedUser"));

			// If we got this far, return the current time...
			return DateTime.Now.ToString();
		}
	}
}
