using System;
using System.IO;
using System.Text;
using System.Xml;

namespace RdrWtr
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		static void Main(string[] args)
		{
			try
			{
				// Create a file stream
				FileStream fstmXmlOut = new FileStream("MyXML.xml",FileMode.Create);

				// Create an encoding
				UTF8Encoding objEncoding = new UTF8Encoding();

				// Create an XML text writer
				XmlTextWriter objXmlWriter = new XmlTextWriter(fstmXmlOut,objEncoding);

				// Create some XML
				objXmlWriter.WriteStartDocument();
				objXmlWriter.WriteStartElement("m","Employees","http://www.myurl.com");
				objXmlWriter.WriteAttributeString("xmlns", "m", null, "http://www.myurl.com");

				// Write an employee element
				objXmlWriter.WriteStartElement("m","Employee","http://www.myurl.com");
				objXmlWriter.WriteStartAttribute("m","id","http://www.myurl.com");
				objXmlWriter.WriteString("175-A15");
				objXmlWriter.WriteEndAttribute();
				objXmlWriter.WriteStartElement("m","Name","http://www.myurl.com");
				objXmlWriter.WriteString("Kenn Scribner");
				objXmlWriter.WriteEndElement(); // Name
				objXmlWriter.WriteStartElement("m","Title","http://www.myurl.com");
				objXmlWriter.WriteString("Code Gecko");
				objXmlWriter.WriteEndElement(); // Title
				objXmlWriter.WriteEndElement(); // Employee

				// Write another employee element
				objXmlWriter.WriteStartElement("m","Employee","http://www.myurl.com");
				objXmlWriter.WriteStartAttribute("m","id","http://www.myurl.com");
				objXmlWriter.WriteString("129-B68");
				objXmlWriter.WriteEndAttribute();
				objXmlWriter.WriteStartElement("m","Name","http://www.myurl.com");
				objXmlWriter.WriteString("Mark Stiver");
				objXmlWriter.WriteEndElement(); // Name
				objXmlWriter.WriteStartElement("m","Title","http://www.myurl.com");
				objXmlWriter.WriteString("Code Godzilla");
				objXmlWriter.WriteEndElement(); // Title
				objXmlWriter.WriteEndElement(); // Employee

				// Finish off the document
				objXmlWriter.WriteEndElement(); // Employees

				// Flush it to the file
				objXmlWriter.Flush();
				objXmlWriter.Close();
				fstmXmlOut.Close();

				// Create a file stream
				FileStream fstmXmlIn = new FileStream("MyXML.xml",FileMode.Open);

				// Create an XML text writer
				XmlTextReader objXmlReader = new XmlTextReader(fstmXmlIn);

				while (objXmlReader.Read())
				{
					switch (objXmlReader.NodeType)
					{
						case XmlNodeType.XmlDeclaration:
							Console.WriteLine("<?xml version=\"1.0\"?>");
							break;

						case XmlNodeType.Element:
							Pad(objXmlReader.Depth);
							Console.Write("<{0}", objXmlReader.Name);
							if ( objXmlReader.HasAttributes )
							{
								bool bAttr = objXmlReader.MoveToFirstAttribute();
								while ( bAttr )
								{
									Console.Write(" {0}=\"{1}\"",objXmlReader.Name, objXmlReader.Value);
									bAttr = objXmlReader.MoveToNextAttribute();
								} // while
							} // if
							Console.WriteLine(">");
							break;
						case XmlNodeType.Text:
							Pad(objXmlReader.Depth);
							Console.WriteLine(objXmlReader.Value);
							break;
						case XmlNodeType.EndElement:
							Pad(objXmlReader.Depth);
							Console.WriteLine("</{0}>", objXmlReader.Name);
							break;
						default:
							break;
					} // switch
				} // while

				// Close the file
				objXmlReader.Close();
				fstmXmlIn.Close();
			} // try
			catch (Exception ex)
			{
				Console.WriteLine("Exception: {0}\n",ex.Message);
			} // catch
		}

		static void Pad(int iDepth)
		{
			for ( int i = 0; i < iDepth; i++ )
			{
				Console.Write("   ");
			} // for
		}
	}
}
