using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Xml;
using System.Xml.XPath;
using System.Xml.Xsl;
using System.Text;

namespace XSLExerciser
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private string m_strXMLPath;
		private string m_strXSLPath;
		private string m_strOutPath;
		private string m_strXMLOutput;
		private XPathDocument m_xpdXMLDoc;
		private MemoryStream m_stmOutput;

		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label lblXMLPath;
		private System.Windows.Forms.Button cmdBrowseXML;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label lblXSLPath;
		private System.Windows.Forms.Button cmdBrowseXSL;
		private System.Windows.Forms.Button cmdXForm;
		private System.Windows.Forms.Button cmdView;
		private System.Windows.Forms.Button cmdExit;
		private System.Windows.Forms.CheckBox optAsText;
		private System.Windows.Forms.CheckBox optSave;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.CheckBox optAsString;
		private System.Windows.Forms.Label lblOutPath;
		private System.Windows.Forms.Button cmdBrowseOut;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.OpenFileDialog ofdXML;
		private System.Windows.Forms.OpenFileDialog ofdXSL;
		private System.Windows.Forms.SaveFileDialog sfdOut;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			m_strXMLPath = "";
			m_strXSLPath = "";
			m_strOutPath = "";
			m_strXMLOutput = "";
			m_xpdXMLDoc = null;
			m_stmOutput = null;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lblXSLPath = new System.Windows.Forms.Label();
			this.cmdXForm = new System.Windows.Forms.Button();
			this.sfdOut = new System.Windows.Forms.SaveFileDialog();
			this.label4 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.cmdView = new System.Windows.Forms.Button();
			this.label3 = new System.Windows.Forms.Label();
			this.cmdBrowseXML = new System.Windows.Forms.Button();
			this.lblOutPath = new System.Windows.Forms.Label();
			this.cmdExit = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.optSave = new System.Windows.Forms.CheckBox();
			this.ofdXML = new System.Windows.Forms.OpenFileDialog();
			this.lblXMLPath = new System.Windows.Forms.Label();
			this.optAsString = new System.Windows.Forms.CheckBox();
			this.cmdBrowseXSL = new System.Windows.Forms.Button();
			this.cmdBrowseOut = new System.Windows.Forms.Button();
			this.ofdXSL = new System.Windows.Forms.OpenFileDialog();
			this.SuspendLayout();
			// 
			// lblXSLPath
			// 
			this.lblXSLPath.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblXSLPath.Location = new System.Drawing.Point(16, 88);
			this.lblXSLPath.Name = "lblXSLPath";
			this.lblXSLPath.Size = new System.Drawing.Size(504, 23);
			this.lblXSLPath.TabIndex = 4;
			// 
			// cmdXForm
			// 
			this.cmdXForm.Enabled = false;
			this.cmdXForm.Location = new System.Drawing.Point(336, 232);
			this.cmdXForm.Name = "cmdXForm";
			this.cmdXForm.Size = new System.Drawing.Size(80, 23);
			this.cmdXForm.TabIndex = 6;
			this.cmdXForm.Text = "XForm";
			this.cmdXForm.Click += new System.EventHandler(this.cmdXForm_Click);
			// 
			// sfdOut
			// 
			this.sfdOut.CreatePrompt = true;
			this.sfdOut.DefaultExt = "xml";
			this.sfdOut.FileName = "doc1";
			this.sfdOut.Filter = "XML Files (*.xml)|*.xml|Text Files (*.txt)|*.txt|All Files (*.*)|*.*||";
			this.sfdOut.Title = "Save XML output to file:";
			// 
			// label4
			// 
			this.label4.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 7.8F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label4.Location = new System.Drawing.Point(192, 136);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(408, 48);
			this.label4.TabIndex = 14;
			this.label4.Text = "Note: viewing output as a string displays output in a text control. To do otherwi" +
				"se displays the output in the Web Browser control.";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(184, 24);
			this.label1.TabIndex = 0;
			this.label1.Text = "XML Document File:";
			// 
			// cmdView
			// 
			this.cmdView.Enabled = false;
			this.cmdView.Location = new System.Drawing.Point(432, 232);
			this.cmdView.Name = "cmdView";
			this.cmdView.Size = new System.Drawing.Size(80, 23);
			this.cmdView.TabIndex = 7;
			this.cmdView.Text = "View";
			this.cmdView.Click += new System.EventHandler(this.cmdView_Click);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 120);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(184, 23);
			this.label3.TabIndex = 9;
			this.label3.Text = "Options:";
			// 
			// cmdBrowseXML
			// 
			this.cmdBrowseXML.Location = new System.Drawing.Point(528, 32);
			this.cmdBrowseXML.Name = "cmdBrowseXML";
			this.cmdBrowseXML.Size = new System.Drawing.Size(80, 24);
			this.cmdBrowseXML.TabIndex = 2;
			this.cmdBrowseXML.Text = "Browse";
			this.cmdBrowseXML.Click += new System.EventHandler(this.cmdBrowseXML_Click);
			// 
			// lblOutPath
			// 
			this.lblOutPath.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblOutPath.Enabled = false;
			this.lblOutPath.Location = new System.Drawing.Point(32, 192);
			this.lblOutPath.Name = "lblOutPath";
			this.lblOutPath.Size = new System.Drawing.Size(488, 24);
			this.lblOutPath.TabIndex = 12;
			// 
			// cmdExit
			// 
			this.cmdExit.Location = new System.Drawing.Point(528, 232);
			this.cmdExit.Name = "cmdExit";
			this.cmdExit.Size = new System.Drawing.Size(80, 23);
			this.cmdExit.TabIndex = 8;
			this.cmdExit.Text = "Exit";
			this.cmdExit.Click += new System.EventHandler(this.cmdExit_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 64);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(184, 23);
			this.label2.TabIndex = 3;
			this.label2.Text = "XSL Stylesheet File:";
			// 
			// optSave
			// 
			this.optSave.Location = new System.Drawing.Point(16, 168);
			this.optSave.Name = "optSave";
			this.optSave.Size = new System.Drawing.Size(176, 24);
			this.optSave.TabIndex = 11;
			this.optSave.Text = "Save output as file";
			this.optSave.CheckedChanged += new System.EventHandler(this.optSave_CheckedChanged);
			// 
			// ofdXML
			// 
			this.ofdXML.DefaultExt = "xml";
			this.ofdXML.Filter = "XML Files (*.xml)|*.xml|Text Files (*.txt)|*.txt|All Files (*.*)|*.*||";
			this.ofdXML.Title = "Load XML File:";
			// 
			// lblXMLPath
			// 
			this.lblXMLPath.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblXMLPath.Location = new System.Drawing.Point(16, 32);
			this.lblXMLPath.Name = "lblXMLPath";
			this.lblXMLPath.Size = new System.Drawing.Size(504, 23);
			this.lblXMLPath.TabIndex = 1;
			// 
			// optAsString
			// 
			this.optAsString.Location = new System.Drawing.Point(16, 144);
			this.optAsString.Name = "optAsString";
			this.optAsString.Size = new System.Drawing.Size(176, 24);
			this.optAsString.TabIndex = 10;
			this.optAsString.Text = "View output as string";
			this.optAsString.CheckedChanged += new System.EventHandler(this.optAsString_CheckedChanged);
			// 
			// cmdBrowseXSL
			// 
			this.cmdBrowseXSL.Enabled = false;
			this.cmdBrowseXSL.Location = new System.Drawing.Point(528, 88);
			this.cmdBrowseXSL.Name = "cmdBrowseXSL";
			this.cmdBrowseXSL.Size = new System.Drawing.Size(80, 24);
			this.cmdBrowseXSL.TabIndex = 5;
			this.cmdBrowseXSL.Text = "Browse";
			this.cmdBrowseXSL.Click += new System.EventHandler(this.cmdBrowseXSL_Click);
			// 
			// cmdBrowseOut
			// 
			this.cmdBrowseOut.Enabled = false;
			this.cmdBrowseOut.Location = new System.Drawing.Point(528, 192);
			this.cmdBrowseOut.Name = "cmdBrowseOut";
			this.cmdBrowseOut.Size = new System.Drawing.Size(80, 24);
			this.cmdBrowseOut.TabIndex = 13;
			this.cmdBrowseOut.Text = "Browse";
			this.cmdBrowseOut.Click += new System.EventHandler(this.cmdBrowseOut_Click);
			// 
			// ofdXSL
			// 
			this.ofdXSL.DefaultExt = "xsl";
			this.ofdXSL.Filter = "XSL Stylesheets (*.xsl)|*.xsl|Text Files (*.txt)|*.txt|All Files (*.*)|*.*||";
			this.ofdXSL.Title = "Load XSL Stylesheet:";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(618, 263);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label4,
																		  this.cmdBrowseOut,
																		  this.lblOutPath,
																		  this.optSave,
																		  this.optAsString,
																		  this.label3,
																		  this.cmdExit,
																		  this.cmdView,
																		  this.cmdXForm,
																		  this.cmdBrowseXSL,
																		  this.lblXSLPath,
																		  this.label2,
																		  this.cmdBrowseXML,
																		  this.lblXMLPath,
																		  this.label1});
			this.Name = "Form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void cmdBrowseXML_Click(object sender, System.EventArgs e)
		{
			try
			{
				// Bring up open file dialog
				if ( ofdXML.ShowDialog() == DialogResult.OK )
				{
					// Enable the UI
					lblXSLPath.Enabled = cmdBrowseXSL.Enabled = true;

					// Store/show the filename
					m_strXMLPath = lblXMLPath.Text = ofdXML.FileName;
				} // if
			} // try
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message,
								"XSLExerciser Error",
								MessageBoxButtons.OK,
								MessageBoxIcon.Error);
			} // catch
		}

		private void cmdBrowseXSL_Click(object sender, System.EventArgs e)
		{
			try
			{
				// Bring up open file dialog
				if ( ofdXSL.ShowDialog() == DialogResult.OK )
				{
					// Enable the UI
					cmdXForm.Enabled = true;

					// Store/show the filename
					m_strXSLPath = lblXSLPath.Text = ofdXSL.FileName;
				} // if
			} // try
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message,
					"XSLExerciser Error",
					MessageBoxButtons.OK,
					MessageBoxIcon.Error);
			} // catch
		}

		private void optAsString_CheckedChanged(object sender, System.EventArgs e)
		{

		}

		private void optSave_CheckedChanged(object sender, System.EventArgs e)
		{
			// Enable the output file label and browse button
			lblOutPath.Enabled = cmdBrowseOut.Enabled = optSave.Checked;
		}

		private void cmdBrowseOut_Click(object sender, System.EventArgs e)
		{
			try
			{
				// Bring up open file dialog
				if ( sfdOut.ShowDialog() == DialogResult.OK )
				{
					// Store/show the filename
					m_strOutPath = lblOutPath.Text = sfdOut.FileName;
				} // if
			} // try
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message,
					"XSLExerciser Error",
					MessageBoxButtons.OK,
					MessageBoxIcon.Error);
			} // catch
		}

		private void cmdXForm_Click(object sender, System.EventArgs e)
		{
			try
			{
				// Open the original XML document
				m_xpdXMLDoc = new XPathDocument(m_strXMLPath);

				// Open the stylesheet
				XslTransform objXSL = new XslTransform();
				objXSL.Load(m_strXSLPath);

				// Create a stream to contain the results
				m_stmOutput = new MemoryStream();

				// Create and overlay an XML writer
				ASCIIEncoding objEncoding = new ASCIIEncoding();
				XmlTextWriter objWriter = new XmlTextWriter(m_stmOutput,objEncoding);

				// Do the transform
				objXSL.Transform(m_xpdXMLDoc,null,objWriter);

				// Save output as a string
				byte[] bytes = m_stmOutput.ToArray(); 
				m_strXMLOutput = objEncoding.GetString(bytes);

				// Check to see if we need to save the file...
				if ( optSave.Checked && m_strOutPath.Length > 0 )
				{
					FileStream fstmXMLOut = new FileStream(m_strOutPath,FileMode.Create);
					m_stmOutput.Position = 0;
					TextReader trFrom = new StreamReader(m_stmOutput);
					TextWriter twTo = new StreamWriter(fstmXMLOut);
					twTo.WriteLine(trFrom.ReadToEnd());
					twTo.Flush();
					fstmXMLOut.Close();
				} // if

				// Close the stream
				m_stmOutput.Close();

				// Enable the UI
				cmdView.Enabled = true;
			} // try
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message,
					"XSLExerciser Error",
					MessageBoxButtons.OK,
					MessageBoxIcon.Error);
			} // catch
		}

		private void cmdView_Click(object sender, System.EventArgs e)
		{
			if ( optAsString.Checked )
			{
				// Display string viewer
				frmViewString v = new frmViewString();
				v.XMLOutput = m_strXMLOutput;
				v.ShowDialog();
			} // if
			else
			{
				// Display browser
				frmViewBrowser v = new frmViewBrowser();
				v.XMLOutput = m_strXMLOutput;
				v.ShowDialog();
			} // else
		}

		private void cmdExit_Click(object sender, System.EventArgs e)
		{
			// Quit
			Application.Exit();
		}
	}
}
