using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.IO.IsolatedStorage;
using System.Text;

namespace XSLExerciser
{
	/// <summary>
	/// Summary description for ViewBrowserForm.
	/// </summary>
	public class ViewBrowserForm : System.Windows.Forms.Form
	{
		private string m_strXMLOutput;
		private AxSHDocVw.AxWebBrowser axWebBrowser1;
		private System.Windows.Forms.Button cmdDone;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ViewBrowserForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ViewBrowserForm));
			this.axWebBrowser1 = new AxSHDocVw.AxWebBrowser();
			this.cmdDone = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.axWebBrowser1)).BeginInit();
			this.SuspendLayout();
			// 
			// axWebBrowser1
			// 
			this.axWebBrowser1.Enabled = true;
			this.axWebBrowser1.Location = new System.Drawing.Point(8, 8);
			this.axWebBrowser1.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("axWebBrowser1.OcxState")));
			this.axWebBrowser1.Size = new System.Drawing.Size(536, 248);
			this.axWebBrowser1.TabIndex = 0;
			// 
			// cmdDone
			// 
			this.cmdDone.Location = new System.Drawing.Point(456, 272);
			this.cmdDone.Name = "cmdDone";
			this.cmdDone.Size = new System.Drawing.Size(88, 24);
			this.cmdDone.TabIndex = 1;
			this.cmdDone.Text = "Done";
			this.cmdDone.Click += new System.EventHandler(this.cmdDone_Click);
			// 
			// frmViewBrowser
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(554, 303);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdDone,
																		  this.axWebBrowser1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "frmViewBrowser";
			this.Text = "Transformed XML within the browser:";
			((System.ComponentModel.ISupportInitialize)(this.axWebBrowser1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		protected override void OnActivated( EventArgs e )
		{
			// <HACK>
			//
			// Ideally you'd like to load the XML information directly into
			// the browser. We can do that using this string:
			//
            //  string str = "about:" + m_strXMLOutput;
			//
			// and then navigate like so:
			//
			// axWebBrowser1.Navigate(str, ...);
			//
			// But this doesn't work...if the XML output is
			// represented by {xml}, the browser shows us this
			// when we view the source:
			//
			// <HTML{xml}</HTML>
			//
			// so it doesn't load correctly.
			//
			// The only way I've found to get it to load
			// correctly is to stuff the XML into a temporary
			// file and navigate to the file...  I consider
			// this a big hack...if anyone reads this code and
			// knows a better way, I'd love to hear about it.
			// You see some of the things I tried...I added a
			// reference to the (COM) "Microsoft HTML Object Library"
			// and tried to write directly to the HTML
			// document...that didn't work because of COM interop.
			//
			// Drop me a note at kenn@endurasoft.com... Thanks!
			//
			// </HACK>
			string strTempFilePath = Path.GetTempPath() + "xmlout.xml";
			try
			{
				FileStream fstmXMLOut = new FileStream(strTempFilePath,FileMode.Create);
				ASCIIEncoding objEncoder = new ASCIIEncoding();
				byte[] bytes = objEncoder.GetBytes(m_strXMLOutput);
				fstmXMLOut.Write(bytes,0,m_strXMLOutput.Length);
				fstmXMLOut.Close();

				Object objNull = new Object();
				axWebBrowser1.Navigate(strTempFilePath,
					ref objNull,
					ref objNull,
					ref objNull,
					ref objNull);
			} // try
			finally
			{
				try
				{
					// Delete (or try to delete) the temp
					// file...
					IsolatedStorageFile isfXMLOut = IsolatedStorageFile.GetStore(IsolatedStorageScope.User | IsolatedStorageScope.Domain | IsolatedStorageScope.Assembly, null, null);
					isfXMLOut.DeleteFile(strTempFilePath);
				} // try
				catch(Exception ex)
				{
					// Ignore the error...leave the file...
				} // catch
			}
#if false
			axWebBrowser1.Navigate("about:blank",
							ref objNull,
							ref objNull,
							ref objNull,
							ref objNull);
			MSHTML.IHTMLDocument2 axDoc = (MSHTML.IHTMLDocument2)axWebBrowser1.Document;
			System.Array arr = System.Array.CreateInstance(m_strXMLOutput.GetType(),1);
			arr.SetValue(m_strXMLOutput,0);
			axDoc.write(arr);
#endif 
		}

		public string XMLOutput
		{
			get
			{
				return m_strXMLOutput;
			}
			set
			{
				m_strXMLOutput = value;
			}
		}

		private void cmdDone_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}
	}
}
