using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Xml;
using System.Xml.XPath;
using System.Xml.Xsl;
using System.Text;

namespace XSLExerciser
{
	/// <summary>
	/// Summary description for MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private string m_strXMLPath;
		private string m_strXSLPath;
		private string m_strOutPath;
		private string m_strXMLOutput;
		private XPathDocument m_objXMLDoc;
		private MemoryStream m_stmOutput;
		private System.Windows.Forms.Button cmdXForm;
		private System.Windows.Forms.Button cmdView;
		private System.Windows.Forms.Button cmdExit;
		private System.Windows.Forms.OpenFileDialog ofdXML;
		private System.Windows.Forms.OpenFileDialog ofdXSL;
		private System.Windows.Forms.SaveFileDialog sfdOut;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button cmdBrowseXML;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label lblXMLPath;
		private System.Windows.Forms.Button cmdBrowseXSL;
		private System.Windows.Forms.Label lblXSLPath;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.RadioButton btnAsBrowser;
		private System.Windows.Forms.RadioButton btnAsText;
		private System.Windows.Forms.CheckBox optSave;
		private System.Windows.Forms.Button cmdBrowseOut;
		private System.Windows.Forms.Label lblOutPath;
		private System.Windows.Forms.Label lblResults;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			m_strXMLPath = "";
			m_strXSLPath = "";
			m_strOutPath = "";
			m_strXMLOutput = "";
			m_objXMLDoc = null;
			m_stmOutput = null;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lblXSLPath = new System.Windows.Forms.Label();
			this.cmdXForm = new System.Windows.Forms.Button();
			this.sfdOut = new System.Windows.Forms.SaveFileDialog();
			this.label4 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.cmdView = new System.Windows.Forms.Button();
			this.cmdBrowseXML = new System.Windows.Forms.Button();
			this.btnAsText = new System.Windows.Forms.RadioButton();
			this.lblOutPath = new System.Windows.Forms.Label();
			this.cmdExit = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.optSave = new System.Windows.Forms.CheckBox();
			this.ofdXML = new System.Windows.Forms.OpenFileDialog();
			this.lblXMLPath = new System.Windows.Forms.Label();
			this.cmdBrowseXSL = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.btnAsBrowser = new System.Windows.Forms.RadioButton();
			this.cmdBrowseOut = new System.Windows.Forms.Button();
			this.lblResults = new System.Windows.Forms.Label();
			this.ofdXSL = new System.Windows.Forms.OpenFileDialog();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// lblXSLPath
			// 
			this.lblXSLPath.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblXSLPath.Location = new System.Drawing.Point(24, 104);
			this.lblXSLPath.Name = "lblXSLPath";
			this.lblXSLPath.Size = new System.Drawing.Size(504, 23);
			this.lblXSLPath.TabIndex = 4;
			// 
			// cmdXForm
			// 
			this.cmdXForm.Enabled = false;
			this.cmdXForm.Location = new System.Drawing.Point(368, 312);
			this.cmdXForm.Name = "cmdXForm";
			this.cmdXForm.Size = new System.Drawing.Size(80, 23);
			this.cmdXForm.TabIndex = 6;
			this.cmdXForm.Text = "XForm";
			this.cmdXForm.Click += new System.EventHandler(this.cmdXForm_Click);
			// 
			// sfdOut
			// 
			this.sfdOut.CreatePrompt = true;
			this.sfdOut.DefaultExt = "xml";
			this.sfdOut.FileName = "doc1";
			this.sfdOut.Filter = "XML Files (*.xml)|*.xml|Text Files (*.txt)|*.txt|All Files (*.*)|*.*||";
			this.sfdOut.Title = "Save XML output to file:";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 24);
			this.label4.Name = "label4";
			this.label4.TabIndex = 15;
			this.label4.Text = "View output:";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(184, 24);
			this.label1.TabIndex = 0;
			this.label1.Text = "XML Document File:";
			// 
			// cmdView
			// 
			this.cmdView.Enabled = false;
			this.cmdView.Location = new System.Drawing.Point(464, 312);
			this.cmdView.Name = "cmdView";
			this.cmdView.Size = new System.Drawing.Size(80, 23);
			this.cmdView.TabIndex = 7;
			this.cmdView.Text = "View";
			this.cmdView.Click += new System.EventHandler(this.cmdView_Click);
			// 
			// cmdBrowseXML
			// 
			this.cmdBrowseXML.Location = new System.Drawing.Point(536, 48);
			this.cmdBrowseXML.Name = "cmdBrowseXML";
			this.cmdBrowseXML.Size = new System.Drawing.Size(80, 24);
			this.cmdBrowseXML.TabIndex = 2;
			this.cmdBrowseXML.Text = "Browse";
			this.cmdBrowseXML.Click += new System.EventHandler(this.cmdBrowseXML_Click);
			// 
			// btnAsText
			// 
			this.btnAsText.Checked = true;
			this.btnAsText.Location = new System.Drawing.Point(32, 48);
			this.btnAsText.Name = "btnAsText";
			this.btnAsText.Size = new System.Drawing.Size(216, 24);
			this.btnAsText.TabIndex = 16;
			this.btnAsText.TabStop = true;
			this.btnAsText.Text = "View output in text control";
			// 
			// lblOutPath
			// 
			this.lblOutPath.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblOutPath.Enabled = false;
			this.lblOutPath.Location = new System.Drawing.Point(32, 120);
			this.lblOutPath.Name = "lblOutPath";
			this.lblOutPath.Size = new System.Drawing.Size(488, 24);
			this.lblOutPath.TabIndex = 12;
			// 
			// cmdExit
			// 
			this.cmdExit.Location = new System.Drawing.Point(560, 312);
			this.cmdExit.Name = "cmdExit";
			this.cmdExit.Size = new System.Drawing.Size(80, 23);
			this.cmdExit.TabIndex = 8;
			this.cmdExit.Text = "Exit";
			this.cmdExit.Click += new System.EventHandler(this.cmdExit_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 80);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(184, 23);
			this.label2.TabIndex = 3;
			this.label2.Text = "XSL Stylesheet File:";
			// 
			// optSave
			// 
			this.optSave.Location = new System.Drawing.Point(16, 96);
			this.optSave.Name = "optSave";
			this.optSave.Size = new System.Drawing.Size(176, 24);
			this.optSave.TabIndex = 11;
			this.optSave.Text = "Save output as file";
			this.optSave.CheckedChanged += new System.EventHandler(this.optSave_CheckedChanged);
			// 
			// ofdXML
			// 
			this.ofdXML.DefaultExt = "xml";
			this.ofdXML.Filter = "XML Files (*.xml)|*.xml|Text Files (*.txt)|*.txt|All Files (*.*)|*.*||";
			this.ofdXML.Title = "Load XML File:";
			// 
			// lblXMLPath
			// 
			this.lblXMLPath.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblXMLPath.Location = new System.Drawing.Point(24, 48);
			this.lblXMLPath.Name = "lblXMLPath";
			this.lblXMLPath.Size = new System.Drawing.Size(504, 23);
			this.lblXMLPath.TabIndex = 1;
			// 
			// cmdBrowseXSL
			// 
			this.cmdBrowseXSL.Enabled = false;
			this.cmdBrowseXSL.Location = new System.Drawing.Point(536, 104);
			this.cmdBrowseXSL.Name = "cmdBrowseXSL";
			this.cmdBrowseXSL.Size = new System.Drawing.Size(80, 24);
			this.cmdBrowseXSL.TabIndex = 5;
			this.cmdBrowseXSL.Text = "Browse";
			this.cmdBrowseXSL.Click += new System.EventHandler(this.cmdBrowseXSL_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.cmdBrowseXML,
																					this.label1,
																					this.lblXMLPath,
																					this.cmdBrowseXSL,
																					this.lblXSLPath,
																					this.label2});
			this.groupBox1.Location = new System.Drawing.Point(8, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(632, 136);
			this.groupBox1.TabIndex = 18;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Files:";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.label4,
																					this.btnAsBrowser,
																					this.btnAsText,
																					this.optSave,
																					this.cmdBrowseOut,
																					this.lblOutPath});
			this.groupBox2.Location = new System.Drawing.Point(8, 152);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(632, 152);
			this.groupBox2.TabIndex = 19;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Options:";
			// 
			// btnAsBrowser
			// 
			this.btnAsBrowser.Location = new System.Drawing.Point(32, 72);
			this.btnAsBrowser.Name = "btnAsBrowser";
			this.btnAsBrowser.Size = new System.Drawing.Size(216, 24);
			this.btnAsBrowser.TabIndex = 17;
			this.btnAsBrowser.Text = "View output in browser";
			// 
			// cmdBrowseOut
			// 
			this.cmdBrowseOut.Enabled = false;
			this.cmdBrowseOut.Location = new System.Drawing.Point(528, 120);
			this.cmdBrowseOut.Name = "cmdBrowseOut";
			this.cmdBrowseOut.Size = new System.Drawing.Size(80, 24);
			this.cmdBrowseOut.TabIndex = 13;
			this.cmdBrowseOut.Text = "Browse";
			this.cmdBrowseOut.Click += new System.EventHandler(this.cmdBrowseOut_Click);
			// 
			// lblResults
			// 
			this.lblResults.Location = new System.Drawing.Point(8, 312);
			this.lblResults.Name = "lblResults";
			this.lblResults.Size = new System.Drawing.Size(352, 23);
			this.lblResults.TabIndex = 20;
			this.lblResults.Text = "Browse for XML file to begin";
			// 
			// ofdXSL
			// 
			this.ofdXSL.DefaultExt = "xsl";
			this.ofdXSL.Filter = "XSL Stylesheets (*.xsl)|*.xsl|Text Files (*.txt)|*.txt|All Files (*.*)|*.*||";
			this.ofdXSL.Title = "Load XSL Stylesheet:";
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(656, 341);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.lblResults,
																		  this.groupBox2,
																		  this.groupBox1,
																		  this.cmdExit,
																		  this.cmdView,
																		  this.cmdXForm});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "MainForm";
			this.Text = "XSL Exerciser Demo Application";
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void cmdBrowseXML_Click(object sender, System.EventArgs e)
		{
			try
			{
				// Bring up open file dialog
				if ( ofdXML.ShowDialog() == DialogResult.OK )
				{
					// Enable the UI
					lblXSLPath.Enabled = cmdBrowseXSL.Enabled = true;

					// Store/show the filename
					m_strXMLPath = lblXMLPath.Text = ofdXML.FileName;

					// Show results
					lblResults.ForeColor = SystemColors.ControlText;
					lblResults.Text = "XML file path recorded, now select stylesheet";
				} // if
			} // try
			catch (Exception ex)
			{
				// Show results
				lblResults.ForeColor = Color.Red;
				lblResults.Text = "Unable to record XML document file path";

				MessageBox.Show(ex.Message,
								"XSLExerciser Error",
								MessageBoxButtons.OK,
								MessageBoxIcon.Error);
			} // catch
		}

		private void cmdBrowseXSL_Click(object sender, System.EventArgs e)
		{
			try
			{
				// Bring up open file dialog
				if ( ofdXSL.ShowDialog() == DialogResult.OK )
				{
					// Enable the UI
					cmdXForm.Enabled = true;

					// Store/show the filename
					m_strXSLPath = lblXSLPath.Text = ofdXSL.FileName;

					// Show results
					lblResults.ForeColor = SystemColors.ControlText;
					lblResults.Text = "Stylesheet file path recorded, now transform";
				} // if
			} // try
			catch (Exception ex)
			{
				// Show results
				lblResults.ForeColor = Color.Red;
				lblResults.Text = "Unable to record stylesheet file path";

				MessageBox.Show(ex.Message,
					"XSLExerciser Error",
					MessageBoxButtons.OK,
					MessageBoxIcon.Error);
			} // catch
		}

		private void optSave_CheckedChanged(object sender, System.EventArgs e)
		{
			// Enable the output file label and browse button
			lblOutPath.Enabled = cmdBrowseOut.Enabled = optSave.Checked;
		}

		private void cmdBrowseOut_Click(object sender, System.EventArgs e)
		{
			try
			{
				// Bring up open file dialog
				if ( sfdOut.ShowDialog() == DialogResult.OK )
				{
					// Store/show the filename
					m_strOutPath = lblOutPath.Text = sfdOut.FileName;
				} // if
			} // try
			catch (Exception ex)
			{
				// Show results
				lblResults.ForeColor = Color.Red;
				lblResults.Text = "Unable to record output XML file path";

				MessageBox.Show(ex.Message,
					"XSLExerciser Error",
					MessageBoxButtons.OK,
					MessageBoxIcon.Error);
			} // catch
		}

		private void cmdXForm_Click(object sender, System.EventArgs e)
		{
			try
			{
				// Open the original XML document
				m_objXMLDoc = new XPathDocument(m_strXMLPath);

				// Open the stylesheet
				XslTransform objXSL = new XslTransform();
				objXSL.Load(m_strXSLPath);

				// Create a stream to contain the results
				m_stmOutput = new MemoryStream();

				// Create and overlay an XML writer
				ASCIIEncoding objEncoding = new ASCIIEncoding();
				XmlTextWriter objWriter = new XmlTextWriter(m_stmOutput,objEncoding);

				// Do the transform
				objXSL.Transform(m_objXMLDoc,null,objWriter);

				// Save output as a string
				byte[] bytes = m_stmOutput.ToArray(); 
				m_strXMLOutput = objEncoding.GetString(bytes);

				// Check to see if we need to save the file...
				if ( optSave.Checked && m_strOutPath.Length > 0 )
				{
					FileStream fstmXMLOut = new FileStream(m_strOutPath,FileMode.Create);
					m_stmOutput.Position = 0;
					TextReader objTRFrom = new StreamReader(m_stmOutput);
					TextWriter objTWTo = new StreamWriter(fstmXMLOut);
					objTWTo.WriteLine(objTRFrom.ReadToEnd());
					objTWTo.Flush();
					fstmXMLOut.Close();
				} // if

				// Close the stream
				m_stmOutput.Close();

				// Enable the UI
				cmdView.Enabled = true;

				// Show results
				lblResults.ForeColor = SystemColors.ControlText;
				lblResults.Text = "Transformation successful, now click View";
			} // try
			catch (Exception ex)
			{
				// Show results
				lblResults.ForeColor = Color.Red;
				lblResults.Text = "Transformation Unsuccessful";

				MessageBox.Show(ex.Message,
					"XSLExerciser Error",
					MessageBoxButtons.OK,
					MessageBoxIcon.Error);
			} // catch
		}

		private void cmdView_Click(object sender, System.EventArgs e)
		{
			if ( btnAsText.Checked )
			{
				// Display string viewer
				ViewStringForm frmViewString = new ViewStringForm();
				frmViewString.XMLOutput = m_strXMLOutput;
				frmViewString.ShowDialog();
			} // if
			else
			{
				// Display browser
				ViewBrowserForm frmViewBrowser = new ViewBrowserForm();
				frmViewBrowser.XMLOutput = m_strXMLOutput;
				frmViewBrowser.ShowDialog();
			} // else
		}

		private void cmdExit_Click(object sender, System.EventArgs e)
		{
			// Quit
			Application.Exit();
		}
	}
}
