<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="xml" omit-xml-declaration="no" version="1.0"/>

<xsl:template match="/">
   <Vehicles>
      <xsl:apply-templates select="Parts"/>
   </Vehicles>
</xsl:template>

<xsl:template match="Parts">
   <Vehicle>
      <Make><xsl:value-of select="Part/@manufacturer"/></Make>
      <Model><xsl:value-of select="Part/@vehicle"/></Model>
      <Parts>
         <xsl:for-each select="Part">
            <Part>
               <Number>
                  <xsl:value-of select="Number"/>
               </Number>
               <Description>
                  <xsl:value-of select="Desc"/>
                  <xsl:text>: </xsl:text>
                  <xsl:value-of select="Comment"/>
               </Description>
               <ModelYears>
                  <xsl:value-of select="MinYear"/>
                  <xsl:text> to </xsl:text>
                  <xsl:value-of select="MaxYear"/>
               </ModelYears>
            </Part>
         </xsl:for-each>
      </Parts>
   </Vehicle>
</xsl:template>


</xsl:stylesheet>
