Imports System.IO
Imports System.Web.Services
Imports System.Web.Services.Protocols

Public Class Header1
    Inherits System.Web.Services.Protocols.SoapHeader

    Dim strHeader As String

    Public Property Header() As String
        Get
            Header = strHeader
        End Get
        Set(ByVal Value As String)
            strHeader = Value
        End Set
    End Property
End Class

<AttributeUsage(AttributeTargets.Method)> _
Public Class SoapDumperAttribute
    Inherits System.Web.Services.Protocols.SoapExtensionAttribute

    Private m_strFilename As String = "C:\SoapLog.txt"
    Private m_iPriority As Integer = 0

    Public Overrides ReadOnly Property ExtensionType() As Type
        Get
            Return GetType(SoapDumper)
        End Get
    End Property

    Public Overrides Property Priority() As Integer
        Get
            Return m_iPriority
        End Get
        Set(ByVal Value As Integer)
            m_iPriority = Value
        End Set
    End Property

    Public Property LogFile() As String
        Get
            Return m_strFilename
        End Get
        Set(ByVal Value As String)
            m_strFilename = Value
        End Set
    End Property
End Class

Public Class SoapDumper
    Inherits System.Web.Services.Protocols.SoapExtension

    Private m_stmOld As Stream
    Private m_stmNew As Stream
    Private m_strFilename As String

    Public Overloads Overrides Function GetInitializer(ByVal methodInfo As LogicalMethodInfo, _
    ByVal attribute As SoapExtensionAttribute) As Object

        Return CType(attribute, SoapDumperAttribute).LogFile
    End Function

    Public Overrides Sub Initialize(ByVal initializer As Object)
        m_strFilename = CStr(initializer)
    End Sub

    Public Overrides Sub ProcessMessage(ByVal message As SoapMessage)
        Select Case message.Stage

            Case SoapMessageStage.BeforeSerialize

            Case SoapMessageStage.AfterSerialize
                LogOutput(message)

            Case SoapMessageStage.BeforeDeserialize
                LogInput(message)

            Case SoapMessageStage.AfterDeserialize

            Case Else
                Throw New Exception("invalid stage")
        End Select
    End Sub

    Public Overrides Function ChainStream(ByVal stream As Stream) As Stream
        m_stmOld = stream
        m_stmNew = New MemoryStream()
        Return m_stmNew
    End Function

    Public Sub LogOutput(ByVal message As SoapMessage)
        Dim fstmLog As New FileStream(m_strFilename, FileMode.Append, FileAccess.Write)
        Dim stmLog As New StreamWriter(fstmLog)
        m_stmNew.Position = 0
        stmLog.WriteLine("---------------------------------- SOAP Response at " _
           + DateTime.Now.ToString())
        stmLog.Flush()
        Copy(m_stmNew, fstmLog)
        fstmLog.Close()
        m_stmNew.Position = 0
        Copy(m_stmNew, m_stmOld)
    End Sub

    Public Sub LogInput(ByVal message As SoapMessage)
        Dim fstmLog As New FileStream(m_strFilename, FileMode.Append, FileAccess.Write)
        Dim stmLog As New StreamWriter(fstmLog)
        Copy(m_stmOld, m_stmNew)
        stmLog.WriteLine("================================== SOAP Request at " _
           + DateTime.Now.ToString())
        stmLog.Flush()
        m_stmNew.Position = 0
        Copy(m_stmNew, fstmLog)
        fstmLog.Close()
        m_stmNew.Position = 0
    End Sub

    Sub Copy(ByVal stmFrom As Stream, ByVal stmTo As Stream)
        Dim trFrom As New StreamReader(stmFrom)
        Dim twTo As New StreamWriter(stmTo)
        twTo.WriteLine(trFrom.ReadToEnd())
        twTo.Flush()
    End Sub
End Class

Public Class Service1
    Inherits System.Web.Services.WebService

    Public m_foo As Header1

#Region " Web Services Designer Generated Code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Web Services Designer.
        InitializeComponent()

        'Add your own initialization code after the InitializeComponent() call

    End Sub

    'Required by the Web Services Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Web Services Designer
    'It can be modified using the Web Services Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container()
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        'CODEGEN: This procedure is required by the Web Services Designer
        'Do not modify it using the code editor.
    End Sub

#End Region

    <WebMethod(), _
     SoapHeader("m_foo"), _
     SoapDumper()> _
    Public Function Foo() As String
        m_foo.DidUnderstand = True
        Foo = m_foo.Header
    End Function

End Class
