Imports VBParmEncoderClient.localhost

Module Module1

    Sub Main()
        ' Create an instance of the proxy
        Dim ws As Service1 = New Service1()

        ' Call the wrapped method. This should save the
        ' serialized SOAP XML to our dump file...
        Dim pt As Point = New Point()
        pt.x = 5
        pt.y = 10
        Dim strReturn As String = ws.WrapParms("Testing...", pt)
        Console.WriteLine("Wrapped method returned '{0}'", strReturn)

        ' Next call the second wrapped method to see the
        ' effects of the namespace on the SOAP elements...
        Dim pt1 As Point1 = New Point1()
        pt1.x = 5
        pt1.y = 10
        strReturn = ws.WrapParms2("Testing...", pt1)
        Console.WriteLine("Second wrapped method returned '{0}'", strReturn)

        ' Next call the bare method, which also saves the
        ' serialized SOAP XML to the dump file, which
        ' we can load to compare... Note that because the
        ' XML namespace didn't change between this method
        ' and the first wrapped parms method, we didn't need
        ' to use the namespace-specific Point struct.
        strReturn = ws.BareParms("Testing...", pt)
        Console.WriteLine("Bare method returned '{0}'", strReturn)

        ' Call the second bare method...
        Dim pt2 As Point2 = New Point2()
        pt2.x = 5
        pt2.y = 10
        strReturn = ws.BareParms2("Testing...", pt2)
        Console.WriteLine("Second bare method returned '{0}'", strReturn)

        ' Finally call the method with renamed SOAP parameters...
        strReturn = ws.RenameParms("Testing...", pt)
        Console.WriteLine("Renamed parameters method returned '{0}'", strReturn)
        Console.Write("(Press <enter> to quit...)")
        Console.ReadLine()

    End Sub

End Module
