﻿//------------------------------------------------------------------------------
// <autogenerated>
//     This code was generated by a tool.
//     Runtime Version: 1.0.2914.16
//
//     Changes to this file may cause incorrect behavior and will be lost if 
//     the code is regenerated.
// </autogenerated>
//------------------------------------------------------------------------------

namespace Ch7CSEx4Cli.localhost {
    using System;
    using System.Diagnostics;
    using System.Xml.Serialization;
	using System.Xml;
	using System.Xml.XPath;
	using System.IO;
	using System.Web;
	using System.Web.Services;
	using System.Web.Services.Protocols;
	using System.Security;
	using System.Security.Cryptography;
	using System.Text;
    
	[AttributeUsage(AttributeTargets.Method)]
	public class SoapEncrypterAttribute : SoapExtensionAttribute 
	{
		private string m_strFilename = "C:\\EncryptLog.txt";
		private int m_iPriority;

		public override Type ExtensionType 
		{
			get
			{
				return typeof(SoapEncrypter);
			}
		}

		public override int Priority 
		{
			get
			{
				return m_iPriority;
			}
			set
			{
				m_iPriority = value;
			}
		}

		public string LogFile 
		{
			get 
			{
				return m_strFilename;
			}
			set 
			{
				m_strFilename = value;
			}
		}
	}

	public class SoapEncrypter : SoapExtension 
	{
		private Stream m_stmOld;
		private Stream m_stmNew;
		private string m_strLogFile;
		private byte[] m_key;
		private byte[] m_iv;

		public SoapEncrypter()
		{
			// Create the DES key...note this and the initialization
			// vector must be the same as that used by the server
			// or the value cannot be decrypted...
			m_key = new byte[8];
			m_key[0] = 104; // random data, but same as server
			m_key[1] = 91;
			m_key[2] = 2;
			m_key[3] = 56;
			m_key[4] = 226;
			m_key[5] = 77;
			m_key[6] = 165;
			m_key[7] = 194;

			// Create the DES initialization vector
			m_iv = new byte[8];
			m_iv[0] = 69;
			m_iv[1] = 148;
			m_iv[2] = 67;
			m_iv[3] = 76;
			m_iv[4] = 139;
			m_iv[5] = 21;
			m_iv[6] = 89;
			m_iv[7] = 247;
		}

		public override object GetInitializer(Type serviceType) 
		{
			return GetType();
		}

		public override object GetInitializer(LogicalMethodInfo methodInfo, SoapExtensionAttribute attribute) 
		{
			return ((SoapEncrypterAttribute)attribute).LogFile;
		}

		public override void Initialize(object initializer) 
		{
			m_strLogFile = (string) initializer;
		}

		public override void ProcessMessage(SoapMessage message) 
		{
			switch (message.Stage) 
			{
				case SoapMessageStage.BeforeSerialize:
					break;

				case SoapMessageStage.AfterSerialize:
					EncryptInput(message);
					break;

				case SoapMessageStage.BeforeDeserialize:
					LogOutput(message);
					break;

				case SoapMessageStage.AfterDeserialize:
					break;

				default:
					throw new Exception("invalid stage");
			}
		}

		public override Stream ChainStream( Stream stream )
		{
			m_stmOld = stream;
			m_stmNew = new MemoryStream();
			return m_stmNew;
		}

		public void EncryptInput( SoapMessage message )
		{
			// Reset the SOAP stream to load into XPath processor
			m_stmNew.Position = 0;

			try
			{
				// Load it and create a navigator
				XmlDocument xdc = new XmlDocument();
				xdc.Load(m_stmNew);

				// Query for the parameter.
				XmlNamespaceManager mgr = new XmlNamespaceManager(xdc.NameTable);
				mgr.AddNamespace("soap","http://schemas.xmlsoap.org/soap/envelope/");
				XmlNode nodeBody = xdc.SelectSingleNode("/soap:Envelope/soap:Body",mgr);
				XmlNode nodeParm = ((XmlNode)nodeBody.FirstChild).FirstChild;

				// Pull element's value as a string
				string strDecrypted = nodeParm.InnerText;

				// Convert the string to a byte array
				UTF8Encoding enc = new UTF8Encoding();
				byte[] bytClear = enc.GetBytes(strDecrypted);

				// Create a stream for encryption
				byte[] bytOut = new byte[4096];
				MemoryStream stmOut = new MemoryStream(bytOut);

				// Create the service provider
				DES des = new DESCryptoServiceProvider();

				// Create the crypto stream and buffer
				CryptoStream stmEncrypt = new CryptoStream(stmOut,des.CreateEncryptor(m_key,m_iv),CryptoStreamMode.Write);

				// Encrypt to memory stream
				stmEncrypt.Write(bytClear,0,bytClear.Length);
				stmEncrypt.FlushFinalBlock();

				// Write XML
				nodeParm.InnerText = Convert.ToBase64String(bytOut,0,(int)stmOut.Position);

				// Write encrypted output to stream.
				m_stmNew.SetLength(0);
				XmlTextWriter xtw = new XmlTextWriter(m_stmNew,new UTF8Encoding());
				xdc.WriteContentTo(xtw);
				xtw.Flush();
			} // try
			catch (Exception)
			{
				// Do nothing, just pass decrypted value through...
			}

			// Create a file to contain the logged output
			FileStream fstmLog = new FileStream(m_strLogFile, FileMode.Append, FileAccess.Write);
			StreamWriter stmLog = new StreamWriter(fstmLog);
			stmLog.WriteLine("---------------------------------- (Encrypted) SOAP Response at " + DateTime.Now);
			stmLog.Flush();

			// Write the encrypted output
			m_stmNew.Position = 0;
			Copy(m_stmNew,fstmLog);
			fstmLog.Close();
			m_stmNew.Position = 0;
			Copy(m_stmNew,m_stmOld);
		}

		public void LogOutput( SoapMessage message )
		{
			// Output logging is the same as for previous
			// SoapExtension (as seen in Chapter 6)
			Copy(m_stmOld,m_stmNew);
			FileStream fstmLog = new FileStream(m_strLogFile, FileMode.Append, FileAccess.Write);
			StreamWriter stmLog = new StreamWriter(fstmLog);
			stmLog.WriteLine("================================== SOAP Request at " + DateTime.Now);
			stmLog.Flush();
			m_stmNew.Position = 0;
			Copy(m_stmNew,fstmLog);
			fstmLog.Close();
			m_stmNew.Position = 0;
		}

		void Copy(Stream stmFrom, Stream stmTo)
		{
			TextReader trFrom = new StreamReader(stmFrom);
			TextWriter twTo = new StreamWriter(stmTo);
			twTo.WriteLine(trFrom.ReadToEnd());
			twTo.Flush();
		}
	}
	
	[System.Web.Services.WebServiceBindingAttribute(Name="Service1Soap", Namespace="http://tempuri.org/")]
    public class Service1 : System.Web.Services.Protocols.SoapHttpClientProtocol {
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
        public Service1() {
            this.Url = "http://localhost/Ch7CSEx4/Service1.asmx";
        }
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("http://tempuri.org/EchoTest", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
		[SoapEncrypter()]
        public string EchoTest(string strEchoMe) {
            object[] results = this.Invoke("EchoTest", new object[] {
                        strEchoMe});
            return ((string)(results[0]));
        }
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
		[SoapEncrypter()]
		public System.IAsyncResult BeginEchoTest(string strEchoMe, System.AsyncCallback callback, object asyncState) 
		{
            return this.BeginInvoke("EchoTest", new object[] {
                        strEchoMe}, callback, asyncState);
        }
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
		[SoapEncrypter()]
		public string EndEchoTest(System.IAsyncResult asyncResult) 
		{
            object[] results = this.EndInvoke(asyncResult);
            return ((string)(results[0]));
        }
    }
}